/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLAreteVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
                            PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
                            PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
                            PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
                            PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
                            PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
                            PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
                            PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
                            PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
                            int K,
                            const char *TypeArete)
{

    int i,j,k;
    double Legerete;  /* Parametre effectif de lgeret*/
    double SignI, SignJ;

    if (!strcmp(TypeArete,"XpYm")||!strcmp(TypeArete,"XpYp")||
            !strcmp(TypeArete,"YpZm")||!strcmp(TypeArete,"YpZp")||
            !strcmp(TypeArete,"ZpXm")||!strcmp(TypeArete,"ZpXp"))
        SignI = +1.0;
    else
        SignI = -1.0;

    if (!strcmp(TypeArete,"XmYp")||!strcmp(TypeArete,"XpYp")||
            !strcmp(TypeArete,"YmZp")||!strcmp(TypeArete,"YpZp")||
            !strcmp(TypeArete,"ZmXp")||!strcmp(TypeArete,"ZpXp"))
        SignJ = +1.0;
    else
        SignJ = -1.0;

    /*  Bloc Arete PML*/

#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=1; j<(W); j++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=TableLegerete[Carte_Tampon[k]];

                Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                                                      (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*(
                                                              SignI*(	(Tii_I[(i+1)*(W+1)*(K)+(j)*(K)+(k)]	+	Tii_J[(i+1)*(W+1)*(K)+(j)*(K)+(k)]	+ Tii_K[(i+1)*(W+1)*(K)+(j)*(K)+(k)]		)
                                                                      -	(Tii_I[(i)*(W+1)*(K)+(j)*(K)+(k)]		+	Tii_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+ Tii_K[(i)*(W+1)*(K)+(j)*(K)+(k)]		)	)	)	);

                Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                      (1-DeltaT*AttenuationPML[2*j])*Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*(
                                                              SignJ*(	(Tij_I[(i)*(W)*(K)+(j)*(K)+(k)]		+ Tij_J[(i)*(W)*(K)+(j)*(K)+(k)]		)
                                                                      -	(Tij_I[(i)*(W)*(K)+(j-1)*(K)+(k)] + Tij_J[(i)*(W)*(K)+(j-1)*(K)+(k)]	)	)	)	);

                Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*(
                                                       (	(Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+ Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                               -	(Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+ Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)])	)	);

            }
        }
    }
#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=0; j<W; j++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=TableLegerete[Carte_Tampon[k]];

                Vj_I[(i)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                    (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(W)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                        SignI*(	(Tij_I[(i)*(W)*(K)+(j)*(K)+(k)]		+		Tij_J[(i)*(W)*(K)+(j)*(K)+(k)]			)
                                                                -	(Tij_I[(i-1)*(W)*(K)+(j)*(K)+(k)]	+		Tij_J[(i-1)*(W)*(K)+(j)*(K)+(k)]		)		)	)	);

                Vj_J[(i)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                    (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(i)*(W)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                        SignJ*(	(Tjj_I[(i)*(W+1)*(K)+(j+1)*(K)+(k)]	+	Tjj_J[(i)*(W+1)*(K)+(j+1)*(K)+(k)]	+	Tjj_K[(i)*(W+1)*(K)+(j+1)*(K)+(k)]	)
                                                                -	(Tjj_I[(i)*(W+1)*(K)+(j)*(K)+(k)]		+	Tjj_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+	Tjj_K[(i)*(W+1)*(K)+(j)*(K)+(k)]	)	)	)	);

                Vj_K[(i)*(W)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*(
                                                     (	(Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(k+1)]	+	Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(k+1)])
                                                             -	(Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(k)]		+	Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(k)]		)	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=1; j<W; j++)
        {
            for (k=1; k<K; k++)
            {

                Legerete=2./(1./TableLegerete[Carte_Tampon[k-1]]+1./TableLegerete[Carte_Tampon[k]]);


                Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                            SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)
                                    -	(Tki_I[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(k)] +	Tki_K[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(k)])	)	)	);

                Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                            SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(k)]		+ Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(k)]	)
                                    -	(Tjk_J[(i)*(W)*(K+1)+(j-1)*(K+1)+(k)] + Tjk_K[(i)*(W)*(K+1)+(j-1)*(K+1)+(k)])	)	)	);

                Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Legerete*(
                        (	(Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(k)]		+	Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(k)]	+	Tkk_K[(i)*(W+1)*(K)+(j)*(K)+(k)])
                            -	(Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(k-1)]	+	Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(k-1)]+	Tkk_K[(i)*(W+1)*(K)+(j)*(K)+(k-1)])	)	);
            }
        }
    }

    /******************************  Face Jm sur PML Face I**********************/

#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (k=0; k<K; k++)
        {

            Legerete=TableLegerete[Carte_Tampon[k]];

            Vi_I[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                                                  (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(K)+(0)*(K)+(k)] + DeltaTsurH*Legerete*(
                                                          SignI*(	(Tii_I[(i+1)*(W+1)*(K)+(0)*(K)+(k)]	+	Tii_J[(i+1)*(W+1)*(K)+(0)*(K)+(k)]	+ Tii_K[(i+1)*(W+1)*(K)+(0)*(K)+(k)]		)
                                                                  -	(Tii_I[(i)*(W+1)*(K)+(0)*(K)+(k)]		+	Tii_J[(i)*(W+1)*(K)+(0)*(K)+(k)]		+ Tii_K[(i)*(W+1)*(K)+(0)*(K)+(k)]		)	)	)	);

            Vi_J[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vi_J[(i)*(W+1)*(K)+(0)*(K)+(k)] + DeltaTsurH*Legerete*(
                                                          SignJ*(	(Tij_I[(i)*(W)*(K)+(0)*(K)+(k)]		+ Tij_J[(i)*(W)*(K)+(0)*(K)+(k)]		)
                                                                  -	(Tij_BufferAreteFaceI[i*(K)+k]																				)	)	)	);

            Vi_K[(i)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*Legerete*(
                                                   (	(Tki_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+ Tki_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                           -	(Tki_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+ Tki_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)])	)	);

        }
    }
#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (k=1; k<K; k++)
        {

            Legerete=2./(1./TableLegerete[Carte_Tampon[k-1]]+1./TableLegerete[Carte_Tampon[k]]);


            Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Tki_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)
                                -	(Tki_I[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(k)] +	Tki_K[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(k)])	)	)	);

            Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(0)*(K+1)+(k)]		+ Tjk_K[(i)*(W)*(K+1)+(0)*(K+1)+(k)]	)
                                -	(Tjk_BufferAreteFaceI[i*(K+1)+k]																						)	)	)	);

            Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)] += DeltaTsurH*Legerete*(
                    (	(Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(k)]		+	Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(k)]	+	Tkk_K[(i)*(W+1)*(K)+(0)*(K)+(k)])
                        -	(Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(k-1)]	+	Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(k-1)]+	Tkk_K[(i)*(W+1)*(K)+(0)*(K)+(k-1)])	)	);
        }
    }

    /******************************  Face Im sur PML Face J******************/

#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (j=0; j<W; j++)
    {
        for (k=0; k<K; k++)
        {

            Legerete=TableLegerete[Carte_Tampon[k]];

            Vj_I[(0)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(W)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                    SignI*(	(Tij_I[(0)*(W)*(K)+(j)*(K)+(k)]		+		Tij_J[(0)*(W)*(K)+(j)*(K)+(k)]			)
                                                            -	(Tij_BufferAreteFaceJ[j*(K)+k]																						)	)	)	);

            Vj_J[(0)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(0)*(W)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                    SignJ*(	(Tjj_I[(0)*(W+1)*(K)+(j+1)*(K)+(k)]	+	Tjj_J[(0)*(W+1)*(K)+(j+1)*(K)+(k)]	+	Tjj_K[(0)*(W+1)*(K)+(j+1)*(K)+(k)]	)
                                                            -	(Tjj_I[(0)*(W+1)*(K)+(j)*(K)+(k)]		+	Tjj_J[(0)*(W+1)*(K)+(j)*(K)+(k)]		+	Tjj_K[(0)*(W+1)*(K)+(j)*(K)+(k)]	)	)	)	);

            Vj_K[(0)*(W)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*(
                                                 (	(Tjk_J[(0)*(W)*(K+1)+(j)*(K+1)+(k+1)]	+	Tjk_K[(0)*(W)*(K+1)+(j)*(K+1)+(k+1)])
                                                         -	(Tjk_J[(0)*(W)*(K+1)+(j)*(K+1)+(k)]		+	Tjk_K[(0)*(W)*(K+1)+(j)*(K+1)+(k)]		)	)	);
        }
    }

#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (j=1; j<W; j++)
    {
        for (k=1; k<K; k++)
        {

            Legerete=2./(1./TableLegerete[Carte_Tampon[k-1]]+1./TableLegerete[Carte_Tampon[k]]);


            Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Tki_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)
                                -	(Tki_BufferAreteFaceJ[j*(K+1)+k]																									)	)	)	);

            Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(j)*(K+1)+(k)]		+ Tjk_K[(0)*(W)*(K+1)+(j)*(K+1)+(k)]	)
                                -	(Tjk_J[(0)*(W)*(K+1)+(j-1)*(K+1)+(k)] + Tjk_K[(0)*(W)*(K+1)+(j-1)*(K+1)+(k)])	)	)	);

            Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Legerete*(
                    (	(Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(k)]		+	Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(k)]	+	Tkk_K[(0)*(W+1)*(K)+(j)*(K)+(k)])
                        -	(Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(k-1)]	+	Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(k-1)]+	Tkk_K[(0)*(W+1)*(K)+(j)*(K)+(k-1)])	)	);
        }
    }

    /******************************  Face Kp sur PML Coin Kp******************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(j,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=1; j<W; j++)
            {

                Legerete=TableLegerete[Carte_Tampon[K-1]];


                Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                            SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]		+	Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]	)
                                    -	(Tki_I[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(K)] +	Tki_K[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(K)])	)	)	);

                Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                            SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(K)]		+ Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(K)]	)
                                    -	(Tjk_J[(i)*(W)*(K+1)+(j-1)*(K+1)+(K)] + Tjk_K[(i)*(W)*(K+1)+(j-1)*(K+1)+(K)])	)	)	);

                Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Legerete*(
                        (	(Tkk_BufferAreteCoinKp[i*(W+1)+j])
                            -	(Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(K-1)]	+	Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(K-1)]+	Tkk_K[(i)*(W+1)*(K)+(j)*(K)+(K-1)])	)	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /******************************  Face Km sur PML Coin Km******************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(j,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=1; j<W; j++)
            {

                Legerete=TableLegerete[Carte_Tampon[0]];


                Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                            SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]		+	Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]	)
                                    -	(Tki_I[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(0)] +	Tki_K[(i-1)*(W+1)*(K+1)+(j)*(K+1)+(0)])	)	)	);

                Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                            SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(0)]		+ Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(0)]	)
                                    -	(Tjk_J[(i)*(W)*(K+1)+(j-1)*(K+1)+(0)] + Tjk_K[(i)*(W)*(K+1)+(j-1)*(K+1)+(0)])	)	)	);

                Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Legerete*(
                        (	(Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(0)]		+	Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(0)]	+	Tkk_K[(i)*(W+1)*(K)+(j)*(K)+(0)])
                            -	(Tkk_BufferAreteCoinKm[i*(W+1)+j])	)	);
            }
        }
    }

    /*Cas de la symetrie est implicite*/
    /*************************   Arete	Face I/Face J *************************/
#pragma omp parallel for private(Legerete) schedule(guided)
    for (k=1; k<K; k++)
    {

        Legerete=2./(1./TableLegerete[Carte_Tampon[k-1]]+1./TableLegerete[Carte_Tampon[k]]);


        Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                    SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Tki_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)
                            -	(Tki_BufferAreteFaceJ[0*(K+1)+k]																									)	)	)	);

        Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)] + DeltaTsurH*Legerete*(
                    SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(0)*(K+1)+(k)]		+ Tjk_K[(0)*(W)*(K+1)+(0)*(K+1)+(k)]	)
                            -	(Tjk_BufferAreteFaceI[0*(K+1)+k]																						)	)	)	);

        Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)] += DeltaTsurH*Legerete*(
                (	(Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(k)]		+	Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(k)]	+	Tkk_K[(0)*(W+1)*(K)+(0)*(K)+(k)])
                    -	(Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(k-1)]	+	Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(k-1)]+	Tkk_K[(0)*(W+1)*(K)+(0)*(K)+(k-1)])	)	);
    }
    /*************************   Arete	Face I/Coin Kp *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {

            Legerete=TableLegerete[Carte_Tampon[K-1]];


            Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)]		+	Tki_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)]	)
                                -	(Tki_I[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(K)] +	Tki_K[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(K)])	)	)	);

            Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(0)*(K+1)+(K)]		+ Tjk_K[(i)*(W)*(K+1)+(0)*(K+1)+(K)]	)
                                -	(Tjk_BufferAreteFaceI[i*(K+1)+K])	)	)	);

            Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(K)] += DeltaTsurH*Legerete*(
                    (	(Tkk_BufferAreteCoinKp[i*(W+1)+0])
                        -	(Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(K-1)]	+	Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(K-1)]+	Tkk_K[(i)*(W+1)*(K)+(0)*(K)+(K-1)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*************************   Arete	Face I/Coin Km *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {

            Legerete=TableLegerete[Carte_Tampon[0]];


            Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)]		+	Tki_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)]	)
                                -	(Tki_I[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(0)] +	Tki_K[(i-1)*(W+1)*(K+1)+(0)*(K+1)+(0)])	)	)	);

            Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(i)*(W)*(K+1)+(0)*(K+1)+(0)]		+ Tjk_K[(i)*(W)*(K+1)+(0)*(K+1)+(0)]	)
                                -	(Tjk_BufferAreteFaceI[i*(K+1)+0])	)	)	);

            Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(0)] += DeltaTsurH*Legerete*(
                    (	(Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(0)]		+	Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(0)]	+	Tkk_K[(i)*(W+1)*(K)+(0)*(K)+(0)])
                        -	(Tkk_BufferAreteCoinKm[i*(W+1)+0])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*************************   Arete	Face J/Coin Kp *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(Legerete) schedule(guided)
        for (j=1; j<W; j++)
        {

            Legerete=TableLegerete[Carte_Tampon[K-1]];


            Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)]		+	Tki_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)]	)
                                -	(Tki_BufferAreteFaceJ[j*(K+1)+K])	)	)	);

            Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(j)*(K+1)+(K)]		+ Tjk_K[(0)*(W)*(K+1)+(j)*(K+1)+(K)]	)
                                -	(Tjk_J[(0)*(W)*(K+1)+(j-1)*(K+1)+(K)] + Tjk_K[(0)*(W)*(K+1)+(j-1)*(K+1)+(K)])	)	)	);

            Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Legerete*(
                    (	(Tkk_BufferAreteCoinKp[0*(W+1)+j])
                        -	(Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(K-1)]	+	Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(K-1)]+	Tkk_K[(0)*(W+1)*(K)+(j)*(K)+(K-1)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*************************   Arete	Face J/Coin Km *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(Legerete) schedule(guided)
        for (j=1; j<W; j++)
        {

            Legerete=TableLegerete[Carte_Tampon[0]];


            Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)]		+	Tki_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)]	)
                                -	(Tki_BufferAreteFaceJ[j*(K+1)+0])	)	)	);

            Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(j)*(K+1)+(0)]		+ Tjk_K[(0)*(W)*(K+1)+(j)*(K+1)+(0)]	)
                                -	(Tjk_J[(0)*(W)*(K+1)+(j-1)*(K+1)+(0)] + Tjk_K[(0)*(W)*(K+1)+(j-1)*(K+1)+(0)])	)	)	);

            Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Legerete*(
                    (	(Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(0)]		+	Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(0)]	+	Tkk_K[(0)*(W+1)*(K)+(j)*(K)+(0)])
                        -	(Tkk_BufferAreteCoinKm[0*(W+1)+j])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*************************   Coin	Face I/Face J/Coin Kp *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYp==0))
    )
    {

        Legerete=TableLegerete[Carte_Tampon[K-1]];


        Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                    SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)]		+	Tki_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)]	)
                            -	(Tki_BufferAreteFaceJ[0*(K+1)+K])	)	)	);

        Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)] + DeltaTsurH*Legerete*(
                    SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(0)*(K+1)+(K)]		+ Tjk_K[(0)*(W)*(K+1)+(0)*(K+1)+(K)]	)
                            -	(Tjk_BufferAreteFaceI[0*(K+1)+K])	)	)	);

        Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(K)] += DeltaTsurH*Legerete*(
                (	(Tkk_BufferAreteCoinKp[0*(W+1)+0])
                    -	(Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(K-1)]	+	Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(K-1)]+	Tkk_K[(0)*(W+1)*(K)+(0)*(K)+(K-1)])	)	);
    }
    /*Cas de la symetrie est implicite*/
    /*************************   Coin	Face I/Face J/Coin Km *************************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYm==0))
    )
    {

        Legerete=TableLegerete[Carte_Tampon[0]];


        Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                    SignI*(	(Tki_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)]		+	Tki_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)]	)
                            -	(Tki_BufferAreteFaceJ[0*(K+1)+0])	)	)	);

        Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)] + DeltaTsurH*Legerete*(
                    SignJ*(	(Tjk_J[(0)*(W)*(K+1)+(0)*(K+1)+(0)]		+ Tjk_K[(0)*(W)*(K+1)+(0)*(K+1)+(0)]	)
                            -	(Tjk_BufferAreteFaceI[0*(K+1)+0])	)	)	); /* !!!!BUG TROUVE A grenoble!*/

        Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(0)] += DeltaTsurH*Legerete*(
                (	(Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(0)]		+	Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(0)]	+	Tkk_K[(0)*(W+1)*(K)+(0)*(K)+(0)])
                    -	(Tkk_BufferAreteCoinKm[0*(W+1)+0])	)	);
    }
    /*Cas de la symetrie est implicite*/
}

