/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLCoinVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
                           PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
                           PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
                           PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
                           PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
                           PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
                           PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
                           PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
                           PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
                           const char *TypeCoin)
{

    int i,j,k;
    double Legerete;  /*Parametre effectif de lgeret*/
    double SignI, SignJ, SignK;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XpYpZm")||
            !strcmp(TypeCoin,"XpYmZp")||!strcmp(TypeCoin,"XpYmZm"))
        SignI = +1.0;
    else
        SignI = -1.0;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XmYpZp")||
            !strcmp(TypeCoin,"XpYpZm")||!strcmp(TypeCoin,"XmYpZm"))
        SignJ = +1.0;
    else
        SignJ = -1.0;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XmYpZp")||
            !strcmp(TypeCoin,"XpYmZp")||!strcmp(TypeCoin,"XmYmZp"))
        SignK = +1.0;
    else
        SignK = -1.0;

    Legerete=TableLegerete[Carte_Tampon[0]];

    /*   Bloc Arete PML	*/

#pragma omp parallel for private(j,k) schedule(guided)
    for (i=0; i<(W); i++)
    {
        for (j=1; j<(W); j++)
        {
            for (k=1; k<(W); k++)
            {


                Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                        (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                            SignI*(	(Tii_I[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+	Tii_J[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Tii_K[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)
                                    -	(Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+	Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)	)	)	);

                Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                            SignJ*(	(Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+	Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		)
                                    -	(Tij_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+	Tij_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]	)	)	)	);

                Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                        (1-DeltaT*AttenuationPML[2*k])*Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                            SignK*(	(Tki_I[(i)*(W+1)*(W)+(j)*(W)+(k)]		+ Tki_K[(i)*(W+1)*(W)+(j)*(W)+(k)]		)
                                    -	(Tki_I[(i)*(W+1)*(W)+(j)*(W)+(k-1)]	+ Tki_K[(i)*(W+1)*(W)+(j)*(W)+(k-1)]		)	)	)	);

            }
        }
    }
#pragma omp parallel for private(j,k) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (j=0; j<(W); j++)
        {
            for (k=1; k<(W); k++)
            {

                Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                        (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                                SignI*(	(Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+	Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		)
                                                                        -	(Tij_I[(i-1)*(W)*(W+1)+(j)*(W+1)+(k)]	+	Tij_J[(i-1)*(W)*(W+1)+(j)*(W+1)+(k)]	)	)	)	);

                Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                        (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                                SignJ*(	(Tjj_I[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+	Tjj_J[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+ Tjj_K[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]		)
                                                                        -	(Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+	Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)	)	)	);

                Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                                                        (1-DeltaT*AttenuationPML[2*k])*Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                                SignK*(	(Tjk_J[(i)*(W)*(W)+(j)*(W)+(k)]		+ Tjk_K[(i)*(W)*(W)+(j)*(W)+(k)]		)
                                                                        -	(Tjk_J[(i)*(W)*(W)+(j)*(W)+(k-1)]	+ Tjk_K[(i)*(W)*(W)+(j)*(W)+(k-1)]		)	)	)	);

            }
        }
    }
#pragma omp parallel for private(j,k) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (j=1; j<(W); j++)
        {
            for (k=0; k<(W); k++)
            {

                Vk_I[(i)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                      (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                              SignI*(	(Tki_I[(i)*(W+1)*(W)+(j)*(W)+(k)]		+ Tki_K[(i)*(W+1)*(W)+(j)*(W)+(k)]		)
                                                                      -	(Tki_I[(i-1)*(W+1)*(W)+(j)*(W)+(k)]	+ Tki_K[(i-1)*(W+1)*(W)+(j)*(W)+(k)]		)	)	)	);

                Vk_J[(i)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                      (1-DeltaT*AttenuationPML[2*j])*Vk_J[(i)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                              SignJ*(	(Tjk_J[(i)*(W)*(W)+(j)*(W)+(k)]	+ Tjk_K[(i)*(W)*(W)+(j)*(W)+(k)]		)
                                                                      -	(Tjk_J[(i)*(W)*(W)+(j-1)*(W)+(k)]+ Tjk_K[(i)*(W)*(W)+(j-1)*(W)+(k)]		)	)	)	);

                Vk_K[(i)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*(
                                                      (1-DeltaT*AttenuationPML[1+2*k])*Vk_K[(i)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                              SignK*(	(Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]	+	Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]+ Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]		)
                                                                      -	(Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+	Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)	)	)	);

            }
        }
    }

    /*************************************************************************/
    /************************  Face Im  **************************************/
    /*************************************************************************/

#pragma omp parallel for private(k) schedule(guided)
    for (j=0; j<(W); j++)
    {
        for (k=1; k<(W); k++)
        {

            Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                    (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                            SignI*(	(Tij_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)]		+	Tij_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)]		)
                                                                    -	(Tij_BufferCoinAreteI[j*(W+1)+k]																													)	)	)	);

            Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                    (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                            SignJ*(	(Tjj_I[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+	Tjj_J[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+ Tjj_K[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]		)
                                                                    -	(Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+	Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)	)	)	);

            Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                                                    (1-DeltaT*AttenuationPML[2*k])*Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                                                            SignK*(	(Tjk_J[(0)*(W)*(W)+(j)*(W)+(k)]		+ Tjk_K[(0)*(W)*(W)+(j)*(W)+(k)]		)
                                                                    -	(Tjk_J[(0)*(W)*(W)+(j)*(W)+(k-1)]	+ Tjk_K[(0)*(W)*(W)+(j)*(W)+(k-1)]		)	)	)	);

        }
    }
#pragma omp parallel for private(k) schedule(guided)
    for (j=1; j<(W); j++)
    {
        for (k=0; k<(W); k++)
        {

            Vk_I[(0)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignI*(	(Tki_I[(0)*(W+1)*(W)+(j)*(W)+(k)]		+ Tki_K[(0)*(W+1)*(W)+(j)*(W)+(k)]		)
                                                                  -	(Tki_BufferCoinAreteI[j*(W)+k]					)	)	)	);

            Vk_J[(0)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                  (1-DeltaT*AttenuationPML[2*j])*Vk_J[(0)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignJ*(	(Tjk_J[(0)*(W)*(W)+(j)*(W)+(k)]	+ Tjk_K[(0)*(W)*(W)+(j)*(W)+(k)]		)
                                                                  -	(Tjk_J[(0)*(W)*(W)+(j-1)*(W)+(k)]+ Tjk_K[(0)*(W)*(W)+(j-1)*(W)+(k)]		)	)	)	);

            Vk_K[(0)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*(
                                                  (1-DeltaT*AttenuationPML[1+2*k])*Vk_K[(0)*(W+1)*(W)+(j)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignK*(	(Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]	+	Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]+ Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]		)
                                                                  -	(Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+	Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		)	)	)	);

        }
    }


    /*************************************************************************/
    /************************  Face Jm  **************************************/
    /*************************************************************************/
#pragma omp parallel for private(k) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (k=0; k<(W); k++)
        {

            Vk_I[(i)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                  (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignI*(	(Tki_I[(i)*(W+1)*(W)+(0)*(W)+(k)]		+ Tki_K[(i)*(W+1)*(W)+(0)*(W)+(k)]		)
                                                                  -	(Tki_I[(i-1)*(W+1)*(W)+(0)*(W)+(k)]	+ Tki_K[(i-1)*(W+1)*(W)+(0)*(W)+(k)]		)	)	)	);

            Vk_J[(i)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vk_J[(i)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignJ*(	(Tjk_J[(i)*(W)*(W)+(0)*(W)+(k)]	+ Tjk_K[(i)*(W)*(W)+(0)*(W)+(k)]		)
                                                                  -	(Tjk_BufferCoinAreteJ[i*(W)+k]		)	)	)	);

            Vk_K[(i)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*(
                                                  (1-DeltaT*AttenuationPML[1+2*k])*Vk_K[(i)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                          SignK*(	(Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]	+	Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]+ Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]		)
                                                                  -	(Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+	Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		)	)	)	);

        }
    }
#pragma omp parallel for private(k) schedule(guided)
    for (i=0; i<(W); i++)
    {
        for (k=1; k<(W); k++)
        {


            Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                    (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tii_I[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+	Tii_J[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Tii_K[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(k)]		)
                                -	(Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+	Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		)	)	)	);

            Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tij_I[(i)*(W)*(W+1)+(0)*(W+1)+(k)]		+	Tij_J[(i)*(W)*(W+1)+(0)*(W+1)+(k)]		)
                                -	(Tij_BufferCoinAreteJ[i*(W+1)+k]	)	)	)	);

            Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] + DeltaTsurH*Legerete*(
                        SignK*(	(Tki_I[(i)*(W+1)*(W)+(0)*(W)+(k)]		+ Tki_K[(i)*(W+1)*(W)+(0)*(W)+(k)]		)
                                -	(Tki_I[(i)*(W+1)*(W)+(0)*(W)+(k-1)]	+ Tki_K[(i)*(W+1)*(W)+(0)*(W)+(k-1)]		)	)	)	);

        }
    }

    /*************************************************************************/
    /************************  Face Km  **************************************/
    /*************************************************************************/
#pragma omp parallel for private(j) schedule(guided)
    for (i=0; i<(W); i++)
    {
        for (j=1; j<(W); j++)
        {

            Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                    (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                        SignI*(	(Tii_I[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+	Tii_J[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Tii_K[(i+1)*(W+1)*(W+1)+(j)*(W+1)+(0)]		)
                                -	(Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+	Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		)	)	)	);

            Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                        SignJ*(	(Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		+	Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		)
                                -	(Tij_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+	Tij_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]	)	)	)	);

            Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                        SignK*(	(Tki_I[(i)*(W+1)*(W)+(j)*(W)+(0)]		+ Tki_K[(i)*(W+1)*(W)+(j)*(W)+(0)]		)
                                -	(Tki_BufferCoinAreteK[i*(W+1)+j]		)	)	)	);

        }
    }
#pragma omp parallel for private(j) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (j=0; j<(W); j++)
        {

            Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                    (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                            SignI*(	(Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		+	Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		)
                                                                    -	(Tij_I[(i-1)*(W)*(W+1)+(j)*(W+1)+(0)]	+	Tij_J[(i-1)*(W)*(W+1)+(j)*(W+1)+(0)]	)	)	)	);

            Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                    (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                            SignJ*(	(Tjj_I[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]	+	Tjj_J[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]	+ Tjj_K[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]		)
                                                                    -	(Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+	Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		)	)	)	);

            Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                    (1-DeltaT*AttenuationPML[2*0])*Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                            SignK*(	(Tjk_J[(i)*(W)*(W)+(j)*(W)+(0)]		+ Tjk_K[(i)*(W)*(W)+(j)*(W)+(0)]		)
                                                                    -	(Tjk_BufferCoinAreteK[i*(W)+j]		)	)	)	);

        }
    }
    /*************************************************************************/
    /************************  Arete Im/Jm ***********************************/
    /*************************************************************************/
#pragma omp parallel for schedule(guided)
    for (k=0; k<(W); k++)
    {

        Vk_I[(0)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                              (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                      SignI*(	(Tki_I[(0)*(W+1)*(W)+(0)*(W)+(k)]		+ Tki_K[(0)*(W+1)*(W)+(0)*(W)+(k)]		)
                                                              -	(Tki_BufferCoinAreteI[0*(W)+k]					)	)	)	);

        Vk_J[(0)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                              (1-DeltaT*AttenuationPML[2*0])*Vk_J[(0)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                      SignJ*(	(Tjk_J[(0)*(W)*(W)+(0)*(W)+(k)]	+ Tjk_K[(0)*(W)*(W)+(0)*(W)+(k)]		)
                                                              -	(Tjk_BufferCoinAreteJ[0*(W)+k])	)	)	);

        Vk_K[(0)*(W+1)*(W)+(0)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*(
                                              (1-DeltaT*AttenuationPML[1+2*k])*Vk_K[(0)*(W+1)*(W)+(0)*(W)+(k)] + DeltaTsurH*Legerete*(
                                                      SignK*(	(Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]	+	Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]+ Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k+1)]		)
                                                              -	(Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+	Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]		)	)	)	);

    }
    /*************************************************************************/
    /************************  Arete Jm/Km ***********************************/
    /*************************************************************************/
#pragma omp parallel for schedule(guided)
    for (i=0; i<(W); i++)
    {

        Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                    SignI*(	(Tii_I[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+	Tii_J[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Tii_K[(i+1)*(W+1)*(W+1)+(0)*(W+1)+(0)]		)
                            -	(Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+	Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		)	)	)	);

        Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                    SignJ*(	(Tij_I[(i)*(W)*(W+1)+(0)*(W+1)+(0)]		+	Tij_J[(i)*(W)*(W+1)+(0)*(W+1)+(0)]		)
                            -	(Tij_BufferCoinAreteJ[i*(W+1)+0]	)	)	)	);

        Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                    SignK*(	(Tki_I[(i)*(W+1)*(W)+(0)*(W)+(0)]		+ Tki_K[(i)*(W+1)*(W)+(0)*(W)+(0)]		)
                            -	(Tki_BufferCoinAreteK[i*(W+1)+0])	)	)	);

    }

    /*************************************************************************/
    /************************  Arete Km/Im ***********************************/
    /*************************************************************************/

#pragma omp parallel for schedule(guided)
    for (j=0; j<(W); j++)
    {

        Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                        SignI*(	(Tij_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)]		+	Tij_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)]		)
                                                                -	(Tij_BufferCoinAreteI[j*(W+1)+0]																													)	)	)	);

        Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*(
                                                (1-DeltaT*AttenuationPML[1+2*j])*Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                        SignJ*(	(Tjj_I[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]	+	Tjj_J[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]	+ Tjj_K[(0)*(W+1)*(W+1)+(j+1)*(W+1)+(0)]		)
                                                                -	(Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+	Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		)	)	)	);

        Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                (1-DeltaT*AttenuationPML[2*0])*Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(0)] + DeltaTsurH*Legerete*(
                                                        SignK*(	(Tjk_J[(0)*(W)*(W)+(j)*(W)+(0)]		+ Tjk_K[(0)*(W)*(W)+(j)*(W)+(0)]		)
                                                                -	(Tjk_BufferCoinAreteK[0*(W)+j]		)	)	)	);

    }
}

